#ifndef ENGINE_H
#define ENGINE_H

class Mesh
{
	float *data;
	int faceNb, texId;

public:
	Mesh();
	~Mesh();

	bool Load(const char *filename, int texId);
	void Render();
	void Interpolate(Mesh *m1, Mesh *m2, float alpha);
};

#define MAX_FRAMES 64
class AniMesh
{
public:
	Mesh frames[MAX_FRAMES];
	Mesh renderframe;
	int frameNb;

public:
	AniMesh();
	~AniMesh();

	bool Load(const char *filename, int texId);
};

class AniObject
{
public:
	AniMesh *aniMesh;
	float curTime, animSpeed;
	int animFirst, animNb;

	AniObject(AniMesh *_aniMesh);
	~AniObject();

	void SetAnim(int first, int nb, float fps);
	void Update(float ticks);
	void Render();
};

class Font
{
	int listBase;

public:
	void Load(const char *fontname, int size);
	void Print(float x, float y, const char *text, ...);
};

#endif
