#include "common.h"

GameTimer gTimer;

void GameTimer::Init()
{
	__int64 freq;
	if(QueryPerformanceFrequency((LARGE_INTEGER *) &freq))
	{
		useQpc = true;
		qpcFreq = 1.f / float(freq);
		QueryPerformanceCounter((LARGE_INTEGER *) &qpcLastTick);
	}
	else
	{
		// QueryPerformanceCounter not available fall back to GetTickCount
		useQpc = false;
		gtcLastTick = GetTickCount();
	}

	fpsCount = 0;
	fpsTime = 0.f;
	fps = 0.f;
}

float GameTimer::Tick()
{
	if(useQpc)
	{
		__int64 tick;
		QueryPerformanceCounter((LARGE_INTEGER *) &tick);
		delta = (tick-qpcLastTick) * qpcFreq;
		qpcLastTick = tick;
	}
	else
	{
		int tick;
		tick = GetTickCount();
		delta = (tick-gtcLastTick) / 1000.f;
		gtcLastTick = tick;
	}

	if(delta > .2f)
		delta = .2f;


	// fps counter
	fpsCount++;
	fpsTime += delta;
	if(fpsTime>1.f)
	{
		fps = float(fpsCount) / fpsTime;
		fpsCount = 0;
		fpsTime = 0.f;
	}

	return delta;
}

